diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
index 589409b52..dac540d6e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
@@ -1,12 +1,10 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.RenderBlocks;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.blockentity.TileEntityRenderer;
+import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Blocks;
@@ -20,7 +18,6 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
 {
     private final Minecraft mc;
     private BlocksContainer container = null;
-    private RenderBlocks containerRenderBlock = null;
 
 
     public EntityRendererFallingBlock()
@@ -33,7 +30,6 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
     public void render(Tessellator tessellator, EntityFallingBlock fallingBlock, double x, double y, double z, float yaw, float partialTick) {
         if (container == null || container.world != fallingBlock.world) {
             container = new BlocksContainer(fallingBlock.world);
-            containerRenderBlock = new RenderBlocks(container);
         }
         GL11.glPushMatrix();
         GL11.glTranslated(x, y, z);
@@ -56,11 +52,10 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
 
         tessellator.startDrawingQuads();
         tessellator.setTranslation(-blockX - 0.5, -blockY - 0.5, -blockZ - 0.5);
-        BlockModel.setRenderBlocks(containerRenderBlock);
 
         container.setLightReferenceEntity(fallingBlock);
         container.setBlock(blockX, blockY, blockZ, fallingBlock.carriedBlock.blockId, fallingBlock.carriedBlock.metadata, fallingBlock.carriedBlock.entity);
-        BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(fallingBlock.carriedBlock.blockId)).renderNoCulling(Tessellator.instance, blockX, blockY, blockZ);
+        BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(fallingBlock.carriedBlock.blockId)).renderNoCulling(Tessellator.instance, container, blockX, blockY, blockZ);
         container.setLightReferenceEntity(null);
         container.clear();
 
@@ -70,7 +65,7 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
         Lighting.enableLight();
         GL11.glPopMatrix();
 
-        TileEntityRenderer<TileEntity> renderer = BlockEntityRenderDispatcher.instance.getRenderer(fallingBlock.carriedBlock.entity);
+        TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(fallingBlock.carriedBlock.entity);
         if (renderer != null) {
             GL11.glPushMatrix();
             renderer.doRender(tessellator, fallingBlock.carriedBlock.entity, x - 0.5, y - 0.5, z - 0.5, partialTick);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
index c1e070110..98eb6efcc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
@@ -1,53 +1,34 @@
 package net.minecraft.client.render.entity;
 
-import java.util.Random;
-
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.item.block.ItemBlock;
 import org.lwjgl.opengl.GL11;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.RenderBlocks;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL12;
+import org.useless.dragonfly.DisplayPos;
 
 import static org.lwjgl.opengl.GL11.glPushMatrix;
 
 public class EntityRendererItem extends EntityRenderer<EntityItem>
 {
-	public final RenderBlocks renderBlocks;
-	private final Random random;
-	public boolean useColor;
+
 
 	public EntityRendererItem() {
-		renderBlocks = new RenderBlocks();
-		random = new Random();
-		useColor = true;
 		shadowSize = 0.15F;
 		shadowOpacity = 0.75F;
 	}
 
-	public int getItemColorFromMetadata(Item item, int metadata) {
-		if (item instanceof ItemBlock) {
-			Block<?> block = ((ItemBlock<?>)item).getBlock();
-			return BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
-		}
-		return 0xFFFFFF;
-	}
-
 	public void render(Tessellator tessellator, final EntityItem entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
 		float brightness = 1.0f;
 		if(!LightmapHelper.isLightmapEnabled()) {
 			brightness = entity.getBrightness(partialTick);
 		}
-		random.setSeed(187L);
 		final ItemStack itemstack = entity.item;
 		if(itemstack == null) {
 			return;
@@ -58,7 +39,7 @@ public class EntityRendererItem extends EntityRenderer<EntityItem>
 		}
 		glPushMatrix();
 		final float bobbingOffset = MathHelper.sin((entity.age + partialTick) / 10F + entity.bobOffset) * 0.1F + 0.1F;
-		final float f3 = (float) Math.toDegrees(((entity.age + partialTick) / 20F + entity.bobOffset));
+		final float yw = (float) Math.toDegrees(((entity.age + partialTick) / 20F + entity.bobOffset));
 		byte renderCount = 1;
 		if (entity.item.stackSize > 1) {
 			renderCount = 2;
@@ -69,13 +50,8 @@ public class EntityRendererItem extends EntityRenderer<EntityItem>
 		if (entity.item.stackSize > 20) {
 			renderCount = 4;
 		}
-		GL11.glTranslatef((float) x, (float) y + bobbingOffset, (float) z);
-		GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-		GL11.glEnable(GL11.GL_BLEND);
-		BlockModel.setRenderBlocks(renderBlocks);
-		ItemModelDispatcher.getInstance().getDispatch(item).renderAsItemEntity(Tessellator.instance, entity, random, itemstack, renderCount, f3, brightness, partialTick);
-		GL11.glDisable(GL11.GL_BLEND);
-		GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+		GL11.glTranslated(x, y + bobbingOffset, z);
+		ItemModelDispatcher.getInstance().getDispatch(item).renderItemEntity(tessellator, itemstack, Minecraft.getMinecraft().gameSettings.items3D.value, renderCount, entity.age, yw, brightness, 1f, partialTick);
 		GL11.glPopMatrix();
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
index 91b94b718..a937cccf0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
@@ -9,19 +9,19 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.Global;
-import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
 import org.lwjgl.opengl.GL11;
 
-public class EntityRendererMinecart extends EntityRenderer<MinecartEntity> {
+public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
     public EntityRendererMinecart() {
         shadowSize = 0.5F;
         modelMinecart = new ModelMinecart();
     }
 
     @Override
-    public void render(Tessellator tessellator, MinecartEntity minecart, final double x, final double y, final double z, final float yaw, final float partialTick) {
+    public void render(Tessellator tessellator, EntityMinecart minecart, final double x, final double y, final double z, final float yaw, final float partialTick) {
         GL11.glPushMatrix();
         
         double lerpX = MathHelper.lerp(minecart.xo, minecart.x, partialTick);
@@ -78,7 +78,7 @@ public class EntityRendererMinecart extends EntityRenderer<MinecartEntity> {
             GL11.glRotated(((Math.sin(hurtAngle) * hurtAngle * currentDamage) / 10F) * (float)minecart.hurtDirection, 1.0F, 0.0F, 0.0F);
         }
         // Render block in cart
-        if(minecart.type != MinecartEntity.PASSENGER_CART) {
+        if(minecart.getType() != EntityMinecart.PASSENGER_CART) {
             TextureRegistry.blockAtlas.bind();
             final float scale = 0.75F;
             GL11.glScalef(scale, scale, scale);
@@ -95,21 +95,21 @@ public class EntityRendererMinecart extends EntityRenderer<MinecartEntity> {
             if (doAFlip){
                 GL11.glRotatef(180, 0, 1, 0);
             }
-            switch (minecart.type){
-                case MinecartEntity.CHEST_CART:
+            switch (minecart.getType()){
+                case EntityMinecart.CHEST_CART:
                     Block<?> block;
-                    if ((minecart.typeMeta & 0b0000_0001) != 0) {
+                    if ((minecart.getMeta() & 0b0000_0001) != 0) {
                         block = Blocks.CHEST_PLANKS_OAK_PAINTED;
                     } else {
                         block = Blocks.CHEST_PLANKS_OAK;
                     }
-                    BlockModelDispatcher.getInstance().getDispatch(block).renderBlockOnInventory(tessellator, minecart.typeMeta, brightness, null);
+                    BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, minecart.getMeta(), brightness, 1, null);
                     break;
-                case MinecartEntity.FURNACE_CART:
-                    if (minecart.fuel > 0) {
-                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_ACTIVE).renderBlockOnInventory(tessellator, 0, brightness, null);
+                case EntityMinecart.FURNACE_CART:
+                    if (minecart.getFuel() > 0) {
+                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_ACTIVE).renderStandalone(tessellator, 0, brightness, 1, null);
                     } else {
-                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_IDLE).renderBlockOnInventory(tessellator, 0, brightness, null);
+                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_IDLE).renderStandalone(tessellator, 0, brightness, 1, null);
                     }
                     break;
             }
@@ -120,7 +120,7 @@ public class EntityRendererMinecart extends EntityRenderer<MinecartEntity> {
         }
         bindTexture("/assets/minecraft/textures/entity/cart.png");
         GL11.glScalef(-1F, -1F, 1.0F);
-        modelMinecart.render(0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F);
+        modelMinecart.render(null, 0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F, partialTick);
         GL11.glPopMatrix();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
index 05c78e1eb..22606bde2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -12,11 +11,8 @@ import org.lwjgl.opengl.GL11;
 
 public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
 {
-    private final RenderBlocks blockRenderer;
-
     public EntityRendererTNT()
     {
-        blockRenderer = new RenderBlocks();
         shadowSize = 0.5F;
     }
 
@@ -45,9 +41,8 @@ public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
         TextureRegistry.blockAtlas.bind();
         float brightness = tnt.getBrightness(partialTick);
         if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
-        BlockModel.setRenderBlocks(blockRenderer);
         BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.TNT);
-        model.renderBlockOnInventory(tessellator, 0, brightness, null);
+        model.renderStandalone(tessellator, 0, brightness, 1, null);
         if((tnt.fuse / 5) % 2 == 0)
         {
             GL11.glDisable(GL11.GL_TEXTURE_2D);
@@ -55,7 +50,7 @@ public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
             GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(770, 772);
             GL11.glColor4f(1.0F, 1.0F, 1.0F, f3);
-            model.renderBlockOnInventory(tessellator, 0, 1.0F, null);
+            model.renderStandalone(tessellator, 0, 1.0F, 1, null);
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             GL11.glDisable(GL11.GL_BLEND);
             GL11.glEnable(GL11.GL_LIGHTING);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 15553c76d..771a96bfe 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -46,9 +46,9 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
     {
         GL11.glPushMatrix();
         GL11.glDisable(GL11.GL_CULL_FACE);
-        mainModel.onGround = getSwingProgress(entity, partialTick);
-        if (armorModel != null) armorModel.onGround = mainModel.onGround;
-        if (overlayModel != null) overlayModel.onGround = mainModel.onGround;
+        mainModel.swingProgress = getSwingProgress(entity, partialTick);
+        if (armorModel != null) armorModel.swingProgress = mainModel.swingProgress;
+        if (overlayModel != null) overlayModel.swingProgress = mainModel.swingProgress;
         mainModel.isRiding = entity.isPassenger();
         if (armorModel != null) armorModel.isRiding = mainModel.isRiding;
         if (overlayModel != null) overlayModel.isRiding = mainModel.isRiding;
@@ -61,7 +61,7 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
             float limbSway = limbSway(entity, partialTick);
             setupRotations(entity, limbSway, bodyYaw, partialTick);
             float scale = 0.0625F;
-            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+            GL12.glEnable(GL12.GL_RESCALE_NORMAL);
             GL11.glScalef(-1F, -1F, 1.0F);
             setupScale(entity, partialTick);
             GL11.glTranslatef(0.0F, -24F * scale - 0.0078125F, 0.0F);
@@ -73,21 +73,17 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
             }
             loadEntityTexture(entity);
             GL11.glEnable(GL11.GL_ALPHA_TEST);
-            mainModel.setLivingAnimations(entity, walkProgress, walkSpeed, partialTick);
-            mainModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+            mainModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
             if (overlayModel != null)
             {
-                overlayModel.setLivingAnimations(entity, walkProgress, walkSpeed, partialTick);
                 bindTexture(overlayTexture);
-                overlayModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                overlayModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
             }
-            if (armorModel != null) armorModel.setLivingAnimations(entity, walkProgress, walkSpeed, partialTick);
             for(int renderPass = 0; renderPass < MAX_ARMOR_LAYERS; renderPass++)
             {
                 if(prepareArmor(entity, renderPass, partialTick))
                 {
-                    armorModel.setLivingAnimations(entity, walkProgress, walkSpeed, partialTick);
-                    armorModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                    armorModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
                     GL11.glDisable(GL11.GL_BLEND);
                     GL11.glEnable(GL11.GL_ALPHA_TEST);
                 }
@@ -107,14 +103,14 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
                 if(entity.hurtTime > 0 || entity.deathTime > 0)
                 {
                     GL11.glColor4f(brightness, 0.0F, 0.0F, 0.4F);
-                    mainModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
-                    if (overlayModel != null) overlayModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                    mainModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
+                    if (overlayModel != null) overlayModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
                     for(int k = 0; k < MAX_ARMOR_LAYERS; k++)
                     {
                         if(prepareArmor(entity, k, partialTick))
                         {
                             GL11.glColor4f(brightness, 0.0F, 0.0F, 0.4F);
-                            armorModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                            armorModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
                         }
                     }
 
@@ -126,14 +122,14 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
                     float b = (float)(argb & 0xff) / 255F;
                     float a = (float)(argb >> 24 & 0xff) / 255F;
                     GL11.glColor4f(r, g, b, a);
-                    mainModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
-                    if (overlayModel != null) overlayModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                    mainModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
+                    if (overlayModel != null) overlayModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
                     for(int l = 0; l < MAX_ARMOR_LAYERS; l++)
                     {
                         if(prepareArmor(entity, l, partialTick))
                         {
                             GL11.glColor4f(r, g, b, a);
-                            armorModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                            armorModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
                         }
                     }
 
@@ -184,7 +180,7 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         return (float)entity.tickCount + partialTick;
     }
 
-    protected void renderAdditional(T entity, float f)
+    protected void renderAdditional(T entity, float partialTick)
     {
     }
 
@@ -207,19 +203,19 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
     {
     }
 
-    protected void renderSpecials(Tessellator tessellator, T entity, double d, double d1, double d2)
+    protected void renderSpecials(Tessellator tessellator, T entity, double x, double y, double z)
     {
         if(mc.canRenderEntityLabel())
         {
-            renderLivingLabel(tessellator, entity, Integer.toString(entity.id), d, d1, d2, 64, false);
+            renderLivingLabel(tessellator, entity, Integer.toString(entity.id), x, y, z, 64, false);
         }
         else if (!entity.nickname.isEmpty())
         {
-            renderLivingLabel(tessellator, entity, entity.getDisplayName(), d, d1, d2, 64, true);
+            renderLivingLabel(tessellator, entity, entity.getDisplayName(), x, y, z, 64, true);
         }
     }
 
-    protected void renderLivingLabel(Tessellator tessellator, T entity, String s, double d, double d1, double d2, int maxDistance, boolean depthTest)
+    protected void renderLivingLabel(Tessellator tessellator, T entity, String s, double x, double y, double z, int maxDistance, boolean depthTest)
     {
         final float f = (float) renderDispatcher.camera.distanceTo(entity);
         if (f > maxDistance)
@@ -230,7 +226,7 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         final float f1 = 1.6F;
         final float f2 = 0.01666667F * f1;
         GL11.glPushMatrix();
-        GL11.glTranslatef((float) d + 0.0F, (float) d1 + entity.getHeadHeight() + 0.8f, (float) d2);
+        GL11.glTranslatef((float) x + 0.0F, (float) y + entity.getHeadHeight() + 0.8f, (float) z);
         GL11.glNormal3f(0.0F, 1.0F, 0.0F);
         GL11.glRotatef(-renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
         GL11.glRotatef(renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
index d2be306e3..b7a882126 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
@@ -4,10 +4,12 @@ import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.ModelBiped;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.monster.MobZombieArmored;
 import net.minecraft.core.item.ItemStack;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.DisplayPos;
 
 public class MobRendererBiped<T extends Mob> extends MobRenderer<T>
 {
@@ -22,14 +24,30 @@ public class MobRendererBiped<T extends Mob> extends MobRenderer<T>
 	}
 
 	@Override
-	protected void renderAdditional(T entity, float f) {
-		ItemStack itemstack = entity.getHeldItem();
-		if(itemstack != null) {
-			GL11.glPushMatrix();
-			this.modelBipedMain.armRight.translateTo(0.0625F);
-			BlockModel.setRenderBlocks(this.renderDispatcher.itemRenderer.renderBlocksInstance);
-			ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderItemThirdPerson(Tessellator.instance, renderDispatcher.itemRenderer, entity, itemstack, true);
-			GL11.glPopMatrix();
+	protected void renderAdditional(T entity, float partialTick) {
+		if (entity instanceof IItemHolding) {
+			IItemHolding itemHolder = (IItemHolding) entity;
+			ItemStack itemstack = itemHolder.getHeldItem();
+			if(itemstack != null) {
+				GL11.glPushMatrix();
+				if (((IItemHolding) entity).isLeftHanded()) {
+					modelBipedMain.armLeft.translateTo(0.0625F);
+					GL11.glRotatef(-90, 1, 0, 0);
+					GL11.glRotatef(180, 0, 1, 0);
+					GL11.glScalef(-1, 1, 1);
+					GL11.glTranslatef(1/16f, 2/16f, -10f/16f);
+					ItemModelDispatcher.getInstance().getDispatch(itemstack)
+						.render(Tessellator.instance, entity, itemstack, DisplayPos.THIRD_PERSON_LEFT_HAND, true, 1, entity.getBrightness(partialTick), 1f, partialTick, true);
+				} else {
+					modelBipedMain.armRight.translateTo(0.0625F);
+					GL11.glRotatef(-90, 1, 0, 0);
+					GL11.glScalef(-1, 1, -1);
+					GL11.glTranslatef(1/16f, 2/16f, -10f/16f);
+					ItemModelDispatcher.getInstance().getDispatch(itemstack)
+						.render(Tessellator.instance, entity, itemstack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1, entity.getBrightness(partialTick), 1f, partialTick, false);
+				}
+				GL11.glPopMatrix();
+			}
 		}
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
index c1fc9e3b2..9132a584c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
@@ -1,17 +1,20 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.entity.player.PlayerLocal;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.ModelBiped;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.IArmorWearing;
+import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.*;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.DisplayPos;
 
 public class MobRendererBipedArmored<T extends Mob & IArmorWearing<HumanArmorShape>> extends MobRendererBiped<T> {
     protected ModelBiped modelArmorA;
@@ -29,31 +32,24 @@ public class MobRendererBipedArmored<T extends Mob & IArmorWearing<HumanArmorSha
     }
 
     @Override
-    protected void renderAdditional(T entity, float f) {
+    protected void renderAdditional(T entity, float partialTick) {
         final @Nullable ItemStack stack = entity.getItemInArmorSlot(HumanArmorShape.HEAD);
         if(stack != null) {
             GL11.glPushMatrix();
-            this.modelBipedMain.head.translateTo(0.0625F);
-            if(stack.itemID < Blocks.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(stack.itemID)).shouldItemRender3d())
-            {
-                float scale = 0.625F;
-                GL11.glTranslatef(0.0F, -0.25F, 0.0F);
-                GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
-                GL11.glScalef(scale, -scale, scale);
-                ItemModelDispatcher.getInstance().getDispatch(stack).renderItem(Tessellator.instance, renderDispatcher.itemRenderer, entity, stack);
-            } else if (!(stack.getItem() instanceof IArmorItem)) {
+            modelBipedMain.head.translateTo(0.0625F);
+            if (!(stack.getItem() instanceof IArmorItem)) {
+                GL11.glPushMatrix();
                 GL11.glEnable(GL11.GL_CULL_FACE);
-                float scale = 0.625F;
-                GL11.glTranslatef(0.0F, -0.8F, 0.0F);
-                GL11.glRotatef(180, 0.0F, 0.0F, 1.0F);
-                GL11.glScalef(scale, scale, scale);
-                ItemModelDispatcher.getInstance().getDispatch(stack).renderItemInWorld(Tessellator.instance, entity, stack, entity.getBrightness(f), 1f, true);
+                GL11.glScalef(-0.6f, -0.6f, 0.6f);
+                GL11.glTranslatef(0, 7/16f, 0);
+                ItemModelDispatcher.getInstance().getDispatch(stack).render(Tessellator.instance, null, stack, DisplayPos.HEAD, true, 1, LightmapHelper.isLightmapEnabled() ? 1f : entity.getBrightness(partialTick), 1f, partialTick, true);
                 GL11.glDisable(GL11.GL_CULL_FACE);
+                GL11.glPopMatrix();
             }
             GL11.glPopMatrix();
         }
 
-        super.renderAdditional(entity, f);
+        super.renderAdditional(entity, partialTick);
     }
 
     @Override
@@ -61,9 +57,14 @@ public class MobRendererBipedArmored<T extends Mob & IArmorWearing<HumanArmorSha
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
 
-        ItemStack itemstack = entity.getHeldItem();
-
-        this.modelArmorA.holdingRightHand = this.modelArmorB.holdingRightHand = this.modelBipedMain.holdingRightHand |= itemstack != null;
+        if (entity instanceof IItemHolding) {
+            ItemStack itemstack = ((IItemHolding) entity).getHeldItem();
+            if (((IItemHolding) entity).isLeftHanded()) {
+                this.modelArmorA.holdingLeftHand = this.modelArmorB.holdingLeftHand = this.modelBipedMain.holdingLeftHand |= itemstack != null;
+            } else {
+                this.modelArmorA.holdingRightHand = this.modelArmorB.holdingRightHand = this.modelBipedMain.holdingRightHand |= itemstack != null;
+            }
+        }
         this.modelArmorA.sneaking = this.modelArmorB.sneaking = this.modelBipedMain.sneaking = entity.isSneaking();
         this.modelArmorA.isRiding = this.modelArmorB.isRiding = this.modelBipedMain.isRiding = entity.isPassenger();
 
